﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Infragistics.Windows.DockManager;

namespace DockManagerSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
        
        private void btnAdd_Click(object sender, RoutedEventArgs e)
        {
            var cp = CreateSidePane();
            sp1.Panes.Add(cp);          
        }
        private ContentPane CreateSidePane()
        {
            var cp = new ContentPane();
            cp.Header = "New Unpinned Pane";
            cp.IsPinned = false;
            cp.IsFlyInSuspended = true;
            //cp.LostKeyboardFocus += LostInitialFocus;
            //cp.LostFocus += LostInitialFocus;
            return cp;
        }

        private void LostInitialFocus(object sender, RoutedEventArgs e)
        {
            var cp = sender as ContentPane;
            cp.LostKeyboardFocus -= LostInitialFocus;
            cp.IsFlyInSuspended = false;
        }
        private void dockManager_ActivePaneChanged(object sender, RoutedPropertyChangedEventArgs<ContentPane> e)
        {
            var pane = (sender as XamDockManager).GetPanes(PaneNavigationOrder.VisibleOrder).Where(cp => cp.IsFlyInSuspended).FirstOrDefault();
            if (pane != null)
                pane.IsFlyInSuspended = false;
        }
    }
}
